DECLARE FUNCTION HEX2NUM! (A$)
DECLARE SUB DISPBINARY (BYTE!, BIT!, WHERE!)
DIM LPT(3)

  ' Display screen
  CLS : SCREEN 0, 0, 0, 0: WIDTH 80
  OPEN "LPT.DAT" FOR INPUT AS #1
  INPUT #1, A$, B$, C$
  LPT(1) = HEX2NUM(A$)
  LPT(2) = HEX2NUM(B$)
  LPT(3) = HEX2NUM(C$)
  LPT(0) = 3
  Y = 1
  DO UNTIL EOF(1)
    LETTER$ = INPUT$(1, #1)
    IF LETTER$ = "\" AND NOT EOF(1) THEN
      LETTER$ = INPUT$(1, #1)
      IF LETTER$ = "\" THEN
        PRINT LETTER$
      ELSE
        COLOR INSTR("0123456789ABCDEF", LETTER$) - 1
      END IF
    ELSEIF ASC(LETTER$) = 13 THEN
      Y = Y + 1: IF Y > 25 THEN Y = 25
      LOCATE Y, 1
    ELSEIF ASC(LETTER$) <> 10 THEN
      PRINT LETTER$;
    END IF
  LOOP
  CLOSE #1

  PARALLEL = 1
  DO
    IF PORTINFO = 0 THEN ' Print parallel port info
      PORTINFO = 1: COLOR 15, 0
      PORT = LPT(PARALLEL): pData = 0

      LOCATE 2, 26: PRINT RIGHT$("00" + HEX$(PORT), 3)
      LOCATE 3, 40: PRINT RIGHT$("00" + HEX$(PORT), 3)
      LOCATE 12, 40: PRINT RIGHT$("00" + HEX$(PORT + 1), 3)
      LOCATE 18, 40: PRINT RIGHT$("00" + HEX$(PORT + 2), 3)
      LOCATE 2, 22: PRINT PARALLEL
      OLDpData = -1: OLDFeedback = -1: OLDControl = -1
    ELSE
      OLDpData = pData: OLDFeedback = Feedback: OLDControl = Control
    END IF

    ' Read inputs from parallel port
    pData = INP(PORT)
    Feedback = INP(PORT + 1)
    Control = INP(PORT + 2)
    COLOR 15
    LOCATE 3, 44: PRINT RIGHT$("0" + HEX$(pData), 2)
    LOCATE 12, 44: PRINT RIGHT$("0" + HEX$(Feedback), 2)
    LOCATE 18, 44: PRINT RIGHT$("0" + HEX$(Control), 2)

    A$ = UCASE$(INKEY$) ' Take user input
    IF A$ <> "" THEN
      SELECT CASE A$
      CASE "0", "1", "2", "3", "4", "5", "6", "7" ' Digital output
        pData = pData XOR 2 ^ VAL(A$)
      CASE "F"   ' Tristate outputs
        Control = Control XOR 32
      CASE "E"   ' IRQ enable
        Control = Control XOR 16
      CASE "D"   ' Pin 17 (Select input)
        Control = Control XOR 8
      CASE "C"   ' Initialize
        Control = Control XOR 4
      CASE "B"   ' Auto LF
        Control = Control XOR 2
      CASE "A"   ' Strobe
        Control = Control XOR 1
      CASE CHR$(0) + CHR$(73) ' PgUp
        PARALLEL = PARALLEL - 1: IF PARALLEL < 1 THEN PARALLEL = LPT(0)
        PORTINFO = 0
      CASE CHR$(0) + CHR$(81) ' PgDn
        PARALLEL = PARALLEL + 1: IF PARALLEL > LPT(0) THEN PARALLEL = 1
        PORTINFO = 0
      CASE ELSE
        ' Do nothing
      END SELECT
    END IF

    ' Display status of registers
    IF OLDpData <> pData THEN
      FOR BIT = 0 TO 7
          DISPBINARY pData, BIT, 4 + BIT
      NEXT BIT
    END IF

    IF OLDFeedback <> Feedback THEN
      FOR BIT = 3 TO 7
          DISPBINARY Feedback, BIT, 10 + BIT
      NEXT BIT
    END IF

    IF OLDControl <> Control THEN
      FOR BIT = 0 TO 5
          DISPBINARY Control, BIT, 19 + BIT
      NEXT BIT
    END IF

    ' Write outputs to parallel port
    OUT PORT, pData
    OUT PORT + 2, Control
  LOOP UNTIL A$ = CHR$(27)

END

SUB DISPBINARY (BYTE, BIT, WHERE)
    ' Display input byte in binary form
    LOCATE WHERE, 47
    IF BYTE AND 2 ^ BIT THEN
        COLOR 8: PRINT ""; : COLOR 15: PRINT ""; ' On
    ELSE
        COLOR 15: PRINT ""; : COLOR 8: PRINT ""; ' Off
    END IF
END SUB

FUNCTION HEX2NUM (A$)
  ' R is the return value
  HD$ = "123456789ABCDEF0"
  A$ = UCASE$(A$) + " " ' Ensure there is a non-hex character in the string
  C = 1                 ' Count variable
 
  DO
    D$ = MID$(A$, C, 1)
    C = C + 1
    IF (INSTR(HD$, D$)) THEN R = R * 16 + (INSTR(HD$, D$) MOD 16)
  LOOP WHILE INSTR(HD$, D$)

  HEX2NUM = R
END FUNCTION

